MIDFUNC(3,block_move,(R4 d, R4 s, R4 n))
{
	int src = readreg_specific(s, 4, ESI_INDEX);
	int dst = readreg_specific(d, 4, EDI_INDEX);
	int len = rmw_specific(n, 4, 4, ECX_INDEX);
	
	CLOBBER_CMP;
	raw_cmp_l(dst, src);
	raw_jcc_b_oponly(3);
	uae_s8 *branchadd1 = (uae_s8 *)get_target();
	emit_byte(0);
	
	/* dest < src */
	raw_cld();
	raw_rep_movsb();
	raw_jmp_b_oponly();
	uae_s8 *branchadd2 = (uae_s8 *)get_target();
	emit_byte(0);
	
	/* dest >= src */
	*branchadd1 = (uae_u32)get_target() - (uae_u32)branchadd1 - 1;
	raw_lea_l_brr_indexed(src, len, src, 1, -1);
	raw_lea_l_brr_indexed(dst, len, dst, 1, -1);
	raw_std();
	raw_rep_movsb();
	raw_cld();
	
	/* end if */
	*branchadd2 = (uae_u32)get_target() - (uae_u32)branchadd2 - 1;
	
	unlock2(dst);
	unlock2(src);
	unlock2(len);
}
MENDFUNC(3,block_move,(R4 d, R4 s, R4 n))

 /* 0xA22E: BlockMoveData */
static __inline__ void comp_block_move_data(uae_u32 opcode, bool noflags)
{
	m68k_pc_offset += 2;
	uae_u8 scratchie = S1;
	int srcreg = 8; // _A0
	int dstreg = 9; // _A1
	int lenreg = 0; // _D0
	int src = scratchie++;
	int dst = scratchie++;
	int len = scratchie++;
	get_n_addr(srcreg, src, scratchie);
	get_n_addr(dstreg, dst, scratchie);
	mov_l_rr(len, lenreg);
	block_move(dst, src, len);
	/* Move noErr (0) into _D0, set Z flag */
	if (noflags) {
		dont_care_flags();
		mov_l_ri(len, 0);
		dont_care_flags();
	}
	else {
		start_needflags();
		xor_l(len, len);
		live_flags();
		end_needflags();
	}
	mov_l_rr(lenreg, len);
	forget_about(src);
	forget_about(dst);
	forget_about(len);
	if (m68k_pc_offset > 100)
		sync_m68k_pc();
}

void REGPARAM2 op_block_move_data_comp_ff(uae_u32 opcode)
{
	comp_block_move_data(opcode, false);
}

void REGPARAM2 op_block_move_data_comp_nf(uae_u32 opcode)
{
	comp_block_move_data(opcode, true);
}

/* Interpretive A-Trap replacements */
void REGPARAM2 op_block_move_data_ff(uae_u32 opcode) REGPARAM;
void REGPARAM2 op_block_move_data_nf(uae_u32 opcode) REGPARAM;

static __inline__ void op_block_move_data(uae_u32 opcode, bool noflags)
{
	uae_u32 src = m68k_areg(regs, 0);
	uae_u32 dst = m68k_areg(regs, 1);
	
	if (src != 0 && dst != 0) {
		int len = m68k_dreg(regs, 0);
		memmove(get_real_address(dst), get_real_address(src), len);
	}
	
	m68k_dreg(regs, 0) = 0;
	if (!noflags)
		SET_ZFLG(1);
	m68k_incpc(2);
}

void REGPARAM2 op_block_move_data_ff(uae_u32 opcode)
{
	op_block_move_data(opcode, false);
}

void REGPARAM2 op_block_move_data_nf(uae_u32 opcode)
{
	op_block_move_data(opcode, true);
}
